VERSION 5.00
Begin VB.Form FMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "PlgBltDemo"
   ClientHeight    =   4635
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5415
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4635
   ScaleWidth      =   5415
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.Timer tmrTimer 
      Enabled         =   0   'False
      Interval        =   20
      Left            =   4717
      Top             =   3941
   End
   Begin VB.PictureBox picDest 
      Height          =   3660
      Left            =   277
      ScaleHeight     =   3600
      ScaleWidth      =   4800
      TabIndex        =   2
      Top             =   274
      Width           =   4860
   End
   Begin VB.CheckBox chkUseMask 
      Caption         =   "&Use Mask"
      Height          =   255
      Left            =   277
      TabIndex        =   1
      Top             =   4106
      Width           =   2415
   End
   Begin VB.PictureBox picSource 
      BackColor       =   &H00C0E0FF&
      BorderStyle     =   0  'Kein
      Height          =   1860
      Left            =   120
      ScaleHeight     =   1860
      ScaleWidth      =   3060
      TabIndex        =   0
      Top             =   120
      Width           =   3060
   End
End
Attribute VB_Name = "FMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'********************************
' Win32 API declarations.
'********************************

Private Declare Function PlgBlt Lib "gdi32.dll" (ByVal hdcDest As Long, ByRef lpPoint As POINTAPI, ByVal hdcSrc As Long, ByVal nXSrc As Long, ByVal nYSrc As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hbmMask As Long, ByVal xMask As Long, ByVal yMask As Long) As Long

Private Type POINTAPI
    x As Long
    y As Long
End Type

' LoadImage declaration.
Private Declare Function LoadImage Lib "user32.dll" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal iImageType As Long, ByVal cx As Long, ByVal cy As Long, ByVal fFlags As Long) As Long

' LoadImage() image types.
Private Const IMAGE_BITMAP = 0
Private Const IMAGE_ICON = 1
Private Const IMAGE_CURSOR = 2
Private Const IMAGE_ENHMETAFILE = 3

' LoadImage() flags.
Private Const LR_DEFAULTCOLOR = &H0
Private Const LR_MONOCHROME = &H1
Private Const LR_COLOR = &H2
Private Const LR_COPYRETURNORG = &H4
Private Const LR_COPYDELETEORG = &H8
Private Const LR_LOADFROMFILE = &H10
Private Const LR_LOADTRANSPARENT = &H20
Private Const LR_DEFAULTSIZE = &H40
Private Const LR_LOADMAP3DCOLORS = &H1000
Private Const LR_CREATEDIBHEADER = &H2000
Private Const LR_COPYFROMRESOURCE = &H4000
Private Const LR_SHARED = &H8000

'********************************
' Form-level member variables.
'********************************

Private m_ptPoints(0 To 2) As POINTAPI
Private m_blnDirection As Boolean
Private m_dblAngle As Double
Private m_blnUseMask As Boolean
Private m_lnghbmMaskBitmap As Long
Private m_sw As Long, m_sh As Long
Private m_dw As Long, m_dh As Long
Private m_ox As Long, m_oy As Long
Private m_a As Long
Private m_d As Double

Private Sub RotatePicture(ByVal m_dblAngle As Double)
    
    ' Winkel in Bogenmass konvertieren.
    m_dblAngle = m_dblAngle * 3.14159265358979 / 180
    
    ' Links oben.
    m_ptPoints(0).x = -m_a * Cos(m_d - m_dblAngle) + m_ox
    m_ptPoints(0).y = -m_a * Sin(m_d - m_dblAngle) + m_oy
    
    ' Rechts oben.
    m_ptPoints(1).x = m_a * Cos(m_d + m_dblAngle) + m_ox
    m_ptPoints(1).y = -m_a * Sin(m_d + m_dblAngle) + m_oy
    
    ' Links unten.
    m_ptPoints(2).x = -m_a * Cos(m_d + m_dblAngle) + m_ox
    m_ptPoints(2).y = m_a * Sin(m_d + m_dblAngle) + m_oy
    
    Call picDest.Cls
    If m_blnUseMask Then
        Call PlgBlt(picDest.hDC, m_ptPoints(0), picSource.hDC, 0, 0, picSource.ScaleWidth, picSource.ScaleHeight, m_lnghbmMaskBitmap, 0, 0)
    Else
        Call PlgBlt(picDest.hDC, m_ptPoints(0), picSource.hDC, 0, 0, picSource.ScaleWidth, picSource.ScaleHeight, 0&, 0, 0)
    End If
End Sub

Private Sub chkUseMask_Click()
    m_blnUseMask = CBool(chkUseMask.Value)
End Sub

Private Sub Form_Load()
    Dim strAppPath As String
    strAppPath = App.Path
    If Right$(strAppPath, 1) <> "\" Then
        strAppPath = strAppPath & "\"
    End If
    
    ' Laden der Maskenbitmap.
    m_lnghbmMaskBitmap = LoadImage(0&, strAppPath & "images\cuttlefishmask.bmp", IMAGE_BITMAP, 0&, 0&, LR_DEFAULTSIZE Or LR_DEFAULTCOLOR Or LR_LOADFROMFILE)
    
    With picSource
        .Picture = LoadPicture(strAppPath & "images\cuttlefish.bmp")
        .AutoRedraw = True
        .ScaleMode = vbPixels
        .Visible = False
    End With
    With picDest
        .Picture = LoadPicture(strAppPath & "images\background.jpg")
        .AutoRedraw = True
        .ScaleMode = vbPixels
    End With
    
    ' Einige oft verwendete Werte hier berechnen.
    m_sw = picSource.ScaleWidth
    m_sh = picSource.ScaleHeight
    m_dw = picDest.ScaleWidth
    m_dh = picDest.ScaleHeight
    m_ox = m_dw / 2
    m_oy = m_dh / 2
    m_a = 0.5 * Sqr(m_sw ^ 2 + m_sh ^ 2)
    m_d = Atn(m_sh / m_sw)
    
    ' Startwinkel auf 180 Grad stellen.
    ' Bei unserer Rotationsmethode wird das Bild seitenverkert angezeigt.
    m_dblAngle = 180
    
    Call tmrTimer_Timer
    tmrTimer.Enabled = True
End Sub

Private Sub picDest_Click()
    
    ' Bei Klick Rotationsrichtung ndern.
    m_blnDirection = Not m_blnDirection
End Sub

Private Sub tmrTimer_Timer()
    If m_dblAngle = 360 Then
        m_dblAngle = 0
    Else
        
        ' In 1.4 Grad-Schritten weiterdrehen. Bei 1.0 Grad-Schritten geht das Drehen zu langsam,
        ' bei 1.4 Grad sieht die Bewegung noch fliessend aus.
        m_dblAngle = m_dblAngle + IIf(m_blnDirection, 1.4, -1.4)
        Call RotatePicture(m_dblAngle)
    End If
End Sub
